﻿namespace SoapEndpoint.Tester.Infrastructure;

public static class RtbHelper
{
    public static void HighlightRTF(RichTextBox rtb)
    {
        var k = 0;

        var str = rtb.Text;

        int st, en;
        var lasten = -1;
        while (k < str.Length)
        {
            st = str.IndexOf('<', k);

            if (st < 0)
            {
                break;
            }

            if (lasten > 0)
            {
                rtb.Select(lasten + 1, st - lasten - 1);
                rtb.SelectionColor = HighlightColors.HC_INNERTEXT;
            }

            en = str.IndexOf('>', st + 1);
            if (en < 0)
            {
                break;
            }

            k = en + 1;
            lasten = en;

            if (str[st + 1] == '!')
            {
                rtb.Select(st + 1, en - st - 1);
                rtb.SelectionColor = HighlightColors.HC_COMMENT;
                continue;
            }

            var nodeText = str.Substring(st + 1, en - st - 1);


            var inString = false;

            var lastSt = -1;
            var state = 0;
            /* 0 = before node name
             * 1 = in node name
               2 = after node name
               3 = in attribute
               4 = in string
               */
            int startNodeName = 0, startAtt = 0;
            for (var i = 0; i < nodeText.Length; ++i)
            {
                if (nodeText[i] == '"')
                {
                    inString = !inString;
                }

                if (inString && nodeText[i] == '"')
                {
                    lastSt = i;
                }
                else if (nodeText[i] == '"')
                {
                    rtb.Select(lastSt + st + 2, i - lastSt - 1);
                    rtb.SelectionColor = HighlightColors.HC_STRING;
                }

                switch (state)
                {
                    case 0:
                        if (!char.IsWhiteSpace(nodeText, i))
                        {
                            startNodeName = i;
                            state = 1;
                        }

                        break;
                    case 1:
                        if (char.IsWhiteSpace(nodeText, i))
                        {
                            rtb.Select(startNodeName + st, i - startNodeName + 1);
                            rtb.SelectionColor = HighlightColors.HC_NODE;
                            state = 2;
                        }

                        break;
                    case 2:
                        if (!char.IsWhiteSpace(nodeText, i))
                        {
                            startAtt = i;
                            state = 3;
                        }

                        break;

                    case 3:
                        if (char.IsWhiteSpace(nodeText, i) || nodeText[i] == '=')
                        {
                            rtb.Select(startAtt + st, i - startAtt + 1);
                            rtb.SelectionColor = HighlightColors.HC_ATTRIBUTE;
                            state = 4;
                        }

                        break;
                    case 4:
                        if (nodeText[i] == '"' && !inString)
                        {
                            state = 2;
                        }

                        break;
                }
            }

            if (state == 1)
            {
                rtb.Select(st + 1, nodeText.Length);
                rtb.SelectionColor = HighlightColors.HC_NODE;
            }
        }
    }
}