﻿using SoapEndpoint.Service.Flows.SbEnSk.v1.LogbookService;
using SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v2.ErrorMessage;
using SoapEndpoint.Tester.Scenario.Flow.SbEnSk;

namespace SoapEndpoint.Tester.Scenario.Implementations.SbEnSk;

public class VtlbScenario : SbEnSkScenarioBase
{
    public override string Name => "VTLB Scenario";

    protected override async Task ExecuteAsync()
    {
        StartNewScenario("Scenario 1");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek,
                BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_VtlbVerzoek),
            new ShvFlowItem(BerichtType.SHV_BetaalvoorstelVtlb, BerichtType.SE_BetaalvoorstelAntwoordAkkoord,
                true),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));

        StartNewScenario("Scenario 2");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek,
                BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_VtlbVerzoek),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_BetaalvoorstelAntwoordAkkoord),
            new ShvFlowItem(BerichtType.SHV_RegelingGeaccordeerd));

        StartNewScenario("Bijlage verplicht");

        await Manager.SHV_FlowAsync(Conversation, null,
            new ShvFlowItem(BerichtType.SHV_Saldoverzoek,
                BerichtType.SE_SaldoverzoekAntwoord),
            new ShvFlowItem(BerichtType.SHV_Betaalvoorstel, BerichtType.SE_VtlbVerzoek));

        await Manager.SHV_SendIncorrectMessageAsync(Conversation, BerichtType.SHV_BetaalvoorstelVtlb, null,
            ShvKnooppuntFoutcode.Bijlageverplichtvoorbericht);
    }
}