﻿using AutoMapper;
using Infrastructure.Utils.Xml;

namespace SoapEndpoint.Service.Proxy.Infrastructure;

public class ContentResolver
{
    private readonly IMapper _mapper;

    public ContentResolver(IMapper mapper)
    {
        _mapper = mapper;
    }

    public TModelType Deserialize<TModelType, TMessageType>(string content)
    {
        var message = DataContractSerializeHelper.Deserialize<TMessageType>(content);
        var model = _mapper.Map<TModelType>(message);
        return model;
    }
}