﻿using System.Security.Cryptography.X509Certificates;
using System.ServiceModel;

namespace SoapEndpoint.Service.Proxy.Infrastructure;

public static class ServiceClientHelper
{
    public static TService ConfigureClient<TService>(ClientBase<TService> proxy, X509Certificate2 certificate,
        string? url = null) where TService : class
    {
        if (!string.IsNullOrWhiteSpace(url))
        {
            var builder = new EndpointAddressBuilder(proxy.Endpoint.Address)
            {
                Uri = new Uri(url)
            };
            proxy.Endpoint.Address = builder.ToEndpointAddress();
        }

        // if (proxy.Endpoint.Binding is BasicHttpBinding binding)
        // {
        //     binding.MaxBufferSize = 10000000;
        //     binding.MaxReceivedMessageSize = 10000000;
        //     binding.ReaderQuotas.MaxStringContentLength = 10000000;
        // }

        // Set the client certificate.
        proxy.ClientCredentials.ClientCertificate.Certificate = certificate;
        return (proxy as TService)!;
    }
}